#!/usr/bin/env python
# -*- coding: utf-8 -*-

# An ES Tools replacement on new CS:S update by fratacos
# Version 0.40

#[Added]
#noclip, restrict, restrictall, unrestrict, unrestrictall, getgravity, play, playedict, playplayer, stopsound, deathadd, deaths, deathset, and getdeaths

#[Fixed]
#est_spawn crash
#est_rocket's sound, shake, and explosion
#est_loop and est_stripplayer
#using es.fire instead of es.ServerCommand

#[Known Issues]
#burn, damage, endround, team, shake, rocket are different from EST
#death and restriction functions are fakes
#all commands are in lower cases (this is a limitation of es.regcmd)
#some player selection (ex: #ct) is not compatible with EST

#[TODO]
#start up errors by registering est cvars
#est_allowadvanceddrop
#est_modplayerweapon

#[currently not possible]
#est_effect*
#est_enable_PerUserKeyEvents
#est_DeathSet

import es
#import nativetools as nt
import gamethread
import playerlib
import time
import vecmath

timer = 0
starttime = time.time()
regclientcmd_list = []
restrict_list = {}
gravity_list = {}
modified_deaths = 0
deaths_list = {}
loop_count = 0
allweapons = ["weapon_ak47", "weapon_aug", "weapon_awp", "weapon_c4", "weapon_deagle", "weapon_elite", "weapon_famas", "weapon_fiveseven", "weapon_flashbang", "weapon_g3sg1", "weapon_galil", "weapon_glock", "weapon_hegrenade", "weapon_knife", "weapon_m249", "weapon_m3", "weapon_m4a1", "weapon_mac10", "weapon_mp5navy", "weapon_p228", "weapon_p90", "weapon_scout", "weapon_sg550", "weapon_sg552", "weapon_smokegrenade", "weapon_tmp", "weapon_ump45", "weapon_usp", "weapon_xm1014"]

def adddownload(param):
	es.stringtable("downloadables", param)
def armor(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_ArmorValue", v)
def armoradd(users, value):
	armor(users, "+", value)
def burn(users, time = 0):
	for userid in getusers(users):
		es.fire(userid, "!self", "ignite")
	if int(time) != 0:
		gamethread.delayed(float(time), extinguish, users)
def cash(users, param, value):
	v = int(value)
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CCSPlayer.m_iAccount")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CCSPlayer.m_iAccount", v)
def cashadd(users, value):
	cash(users, "+", value)
def csay(users, text):
	es.usermsg("create", "centermsg", "TextMsg")
	es.usermsg("write", "byte", "centermsg", 4)
	es.usermsg("write", "string", "centermsg", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "centermsg", userid)
	es.usermsg("delete", "centermsg")
def curtime():
	global timer
	return time.time() - timer
def damage(source, target, value):
	if str(source) == "0":
		for userid in getusers(target):
			es.ServerCommand("es_xgive %s point_hurt" % userid)
			es.fire(userid, "point_hurt", "Kill")
			es.fire(userid, "point_hurt", "addoutput", "DamageType 2")
			es.fire(userid, "point_hurt", "addoutput", "Damage %d" % int(value))
			es.fire(userid, "point_hurt", "Hurt")
		return
	for userid in getusers(source):
		source = userid
		break
	for userid in getusers(target):
		es.fire(userid, "!self", "addoutput", "targetname mrdamage")
	es.ServerCommand("es_xgive %s point_hurt" % source)
	es.fire(source, "point_hurt", "Kill")
	es.fire(source, "point_hurt", "addoutput", "DamageType 2")
	es.fire(source, "point_hurt", "addoutput", "Damage %d" % int(value))
	es.fire(source, "point_hurt", "addoutput", "DamageTarget mrdamage")
	es.fire(source, "point_hurt", "Hurt")
def deafen(users, total, percent, fadeout, fadeback):
	for userid in getusers(users):
		es.fadevolume(userid, percent, fadeout, total, fadeback)
def deathadd(users, value):
	deaths(users, "+", value)
def deaths(users, param, v):
	global deaths_list
	global modified_deaths
	if not param in "=+-":
		return
	if modified_deaths == 0:
		modified_deaths = 1
		index = es.getentityindex("cs_player_manager")
		players = playerlib.getPlayerList("#all")
		for userid in players:
			deaths_list[userid] = es.getindexprop(index, "CPlayerResource.m_iDeaths.%.3d" % playerlib.getPlayer(userid).attributes["index"])
	value = int(v)
	for userid in getusers(users):
		if param == "=":
			deaths_list[userid] = value
		if param == "+":
			deaths_list[userid] += value
		if param == "-":
			deaths_list[userid] -= value
def deathset(users, value):
	deaths(users, "=", value)
def deleteragdolls(users = 0):
	if str(users) == "0":
		es.fire(es.getuserid(), "cs_ragdoll", "Kill", 0.15)
		return
	handles = []
	for userid in getusers(users):
		handles.append(es.getplayerhandle(userid))
	ragdolls = es.createentitylist("cs_ragdoll")
	for index in ragdolls:
		if es.getindexprop(index, "CCSRagdoll.m_hPlayer") in handles:
			setentname(index, "theragdoll")	
	es.fire(es.getuserid(), "theragdoll", "Kill", 0.15)
def endround(time, reason):
	t = int(time)
	r = int(reason)
	if not (0 < r and r < 17):
		return
	data = [["#Target_Bombed", 2], ["#VIP_Escaped", 3], ["#VIP_Assassinated", 2], ["#Terrorists_Escaped", 2], ["#CTs_PreventEscape", 3], ["#Escaping_Terrorists_Neutralized", 3], ["#Bomb_Defused", 3], ["#CTs_Win", 3], ["#Terrorists_Win", 2], ["#Round_Draw", 0], ["#All_Hostages_Rescued", 3], ["#Target_Saved", 3], ["#Hostages_Not_Rescued", 2], ["#Terrorists_Not_Escaped", 3], ["#VIP_Not_Escaped", 2], ["#Game_Commencing", 0]]
	winner = data[r - 1][1]
	text = data[r - 1][0]
	es.event("initialize", "round_end")
	es.event("setint", "round_end", "winner", winner)
	es.event("setint", "round_end", "reason", r)
	es.event("setstring", "round_end", "message", text)
	es.event("fire", "round_end")
	gamethread.delayed(t, endround_delayed1, (t, text))
	gamethread.delayed(t + 0.20, endround_delayed2, (t, text))
def endround_delayed1(t, text):
	es.flags("remove", "cheat", "endround")
	es.ServerCommand("endround")
def endround_delayed2(t, text):
	es.flags("add", "cheat", "endround")
	if t >= 2:
		es.centermsg("")
	else:
		es.centermsg(text)
def entteleport(index, x, y, z):
	setentname(index, "theentity")
	es.fire(es.getuserid(), "theentity", "addoutput", "origin %d %d %d" % (float(x), float(y), float(z)))
def extinguish(users):
	flames = es.createentitylist("entityflame")
	handlelist = []
	for userid in getusers(users):
		handle = es.getplayerhandle(es.getuserid(userid))
		handlelist.append(handle)
	for index in flames:
		target = es.getindexprop(index, "CEntityFlame.m_hEntAttached")
		if target in handlelist:
			es.setindexprop(index, "CEntityFlame.m_hEntAttached", 0)
def fade(users, type, fadetime, totaltime, r, g, b, a):
	t = int(type)
	if t == 1:
		type = 2
	elif t == 0:
		type = 1
	else:
		type = 8 + 16
	es.usermsg("create", "fade", "Fade")
	es.usermsg("write", "short", "fade", int(fadetime) * 1000)
	es.usermsg("write", "short", "fade", int(totaltime) * 1000)
	es.usermsg("write", "short", "fade", int(type))
	es.usermsg("write", "byte", "fade", int(r))
	es.usermsg("write", "byte", "fade", int(g))
	es.usermsg("write", "byte", "fade", int(b))
	es.usermsg("write", "byte", "fade", int(a))
	for userid in getusers(users):
		es.usermsg("send", "fade", userid)
	es.usermsg("delete", "fade")
def freeze(users, param = 1):
	# we can't bit operate directly because movetype is not proper integer
	for userid in getusers(users):
		movetype = es.getplayerprop(userid, "CBaseEntity.movetype")
		if str(param) == "1":
			if movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype - 2)
		else:
			if not movetype & 2:
				es.setplayerprop(userid, "CBaseEntity.movetype", movetype + 2)
def getammo(users, param):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			return player.ammo.primary
		if secondary in name:
			return player.ammo.secondary
def getarmor(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CCSPlayer.m_ArmorValue")
def getclipammo(users, param):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			return player.clip.primary
		if secondary in name:
			return player.clip.secondary
def getdeaths(users):
	global deaths_list
	global modified_deaths
	if modified_deaths != 0:
		for userid in getusers(users):
			return deaths_list[userid]
	else:
		index = es.getentityindex("cs_player_manager")
		for userid in getusers(users):
			return es.getindexprop(index, "CPlayerResource.m_iDeaths.%.3d" % playerlib.getPlayer(userid).attributes["index"])
def getfb(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getFB()
def getgravity(users):
	global gravity_list
	for userid in getusers(users):
		return gravity_list[userid]
def getgun(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).weapon
def gethe(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getHE()
def gethealth(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CBasePlayer.m_iHealth")
def getindex(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).attributes["index"]
def getkills(users):
	index = es.getentityindex("cs_player_manager")
	for userid in getusers(users):
		return es.getindexprop(index, "CPlayerResource.m_iScore.%.3d" % playerlib.getPlayer(userid).attributes["index"])
def getname(users):
	for userid in getusers(users):
		return es.getplayername(userid)
def getprimary(users):
	for userid in getusers(users):
		name = playerlib.getPlayer(userid).getPrimary()
		if name != 0:
			return name
	return "weapon_none"
def getsecondary(users):
	for userid in getusers(users):
		name = playerlib.getPlayer(userid).getSecondary()
		if name != 0:
			return name
	return "weapon_none"
def getsg(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).getSG()
def getslot(users, param):
	if not str(param) in "1234":
		return
	for userid in getusers(users):
		weapons = getweaponname(userid, param)
		if weapons == [ "weapon_none" ]:
			continue
		if len(weapons) > 0:
			return weapons[0]
	return "weapon_none"
def getsteam(users):
	for userid in getusers(users):
		return es.getplayersteamid(userid)
def getteam(users):
	for userid in getusers(users):
		return es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
def getuserid(users):
	for userid in getusers(users):
		return userid
def getweaponindex(users, param):
	handles = []
	for userid in getusers(users):
		handles.append(es.getplayerhandle(userid))
	name = getweaponname(userid, param)
	if name == ["weapon_none"]:
		return 0
	for item in name:
		weapon = es.createentitylist(item)
		for index in weapon:
			if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") in handles:
				return index
	return 0
def god(users, param = 1):
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		if not dead:
			if str(param) == "1":
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 0)
			else:
				es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
def hasdefuser(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).hasDefuser()
	return 0
def hashelmet(users):
	for userid in getusers(users):
		return playerlib.getPlayer(userid).hasHelmet()
	return 0
def haskevlar(users):
	for userid in getusers(users):
		if es.getplayerprop(userid, "CCSPlayer.m_ArmorValue") > 0:
			return 1
		else:
			return 0
	return 0
def health(users, param, value = 0):
	v = int(value)
	if v == 0:
		v = int(param)
		param = "="
	for userid in getusers(users):
		if param in "+-":
			now = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
			if param == "+":
				now += v
			if param == "-":
				now -= v
			v = now
		if param in "=+-":
			es.setplayerprop(userid, "CBasePlayer.m_iHealth", v)
def healthadd(users, value):
	health(users, "+", value)
def hsay(users, text):
	es.usermsg("create", "hudhint", "HintText")
	es.usermsg("write", "string", "hudhint", unicode(text))
	for userid in getusers(users):
		es.usermsg("send", "hudhint", userid)
	es.usermsg("delete", "hudhint")
def jetpack(users, param):
	p = int(param)
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.jetpack(p)
def killadd(users, v):
	kills(users, "+", v)
def kills(users, param, v):
	value = int(v)
	trigger = es.getuserid()
	es.ServerCommand("es_xgive %s game_score" % trigger)
	es.fire(trigger, "game_score", "addoutput", "spawnflags 1")
	if param == "+":
		apply = value
	if param == "-":
		apply = -value
	for userid in getusers(users):
		if param == "=":
			apply = value - getkills(userid)
		es.fire(userid, "game_score", "addoutput", "points %d" % apply)
		es.fire(userid, "game_score", "ApplyScore")
	es.fire(trigger, "game_score", "Kill")
def killset(users, v):
	kills(users, "=", v)
def loop(variable, users, command):
	for userid in getusers(users):
		es.ServerCommand("%s %s" % (variable, userid))
		es.ServerCommand(command)
def motd(users, title, type, msg):
	data = { "title":title, "type":type, "msg":msg }
	es.usermsg('create', 'panel', 'VGUIMenu')
	es.usermsg('write', 'string', 'panel', "info")
	es.usermsg('write', 'byte', 'panel', 1)
	es.usermsg('write', 'byte', 'panel', len(data))
	for item in data:
		es.usermsg('write', 'string', 'panel', item)
		es.usermsg('write', 'string', 'panel', data[item])
	for userid in getusers(users):
		es.usermsg('send', 'panel', userid)
	es.usermsg('delete', 'panel')
def motd_f(users, title, command, path):
	motd(users, unicode(title), "3", path)
def motd_t(users, title, command, text):
	motd(users, unicode(title), "0", unicode(text))
def motd_w(users, title, command, url):
	motd(users, unicode(title), "2", url)
def msg(users, value):
	for userid in getusers(users):
		es.tell(userid, "#multi", value)
def name(users, value):
	for userid in getusers(users):
		if es.getplayersteamid(userid) == "BOT":
			es.botsetvalue(userid, "name", value)
		else:
			es.cexec(userid, "name %s" % value)
def noclip(users, value):
	if int(value) == 1:
		v = 1
	else:
		v = 0
	for userid in getusers(users):
		playerlib.getPlayer(userid).noclip(v)
def physpush(users, x, y, z):
	xx = float(x)
	yy = float(y)
	zz = float(z)
	if xx == 0 and yy == 0 and zz == 0:
		for userid in getusers(users):
			xx = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[0]")
			yy = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[1]")
			zz = es.getplayerprop(userid, "CBasePlayer.localdata.m_vecVelocity[2]")
			es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (-xx, -yy, -zz))
		return
	for userid in getusers(users):
		vec = vecmath.vector(es.getplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity"))
		es.setplayerprop(userid, "CBasePlayer.localdata.m_vecBaseVelocity", "%f,%f,%f" % (xx + vec[0], yy + vec[1], zz + vec[2]))
def play(users, param, duration = 0, volume = 1.0):
	d = float(duration)
	v = float(volume)
	for userid in getusers(users):
		es.playsound(userid, param, v)
	if d != 0:
		gamethread.delayed(d, stopsound, (userid, param))
def playedict(index, param, volume = 1.0, attenuation = 0.5):
	v = float(volume)
	a = float(attenuation)
	es.emitsound("entity", int(index), param, v, a)
def playplayer(users, param, volume = 1.0, attenuation = 0.5):
	v = float(volume)
	a = float(attenuation)
	for userid in getusers(users):
		es.emitsound("player", userid, param, v, a)
def regclientcmd(command, type):
	global regclientcmd_list
	if str(type) == "1":
		t = 1
	else:
		t = 0
	regclientcmd_list.append([command, t])
def remove(param):
	es.fire(es.getuserid(), str(param), "Kill")
def removeidle(param):
	if param == "weapon":
		global allweapons
		for weapon in allweapons:
			removeidle(weapon)
		return
	weapon = es.createentitylist(param)
	for index in weapon:
		if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == -1:
			setentname(index, "theweapon")
	es.fire(es.getuserid(), "theweapon", "Kill")
def removeweapon(users, param):
	handles = {}
	flag = 0
	weapons = []
	if str(param) in "1234":
		flag = 1
	else:
		weapons = [param]
	for userid in getusers(users):
		handle = es.getplayerhandle(userid)
		if flag:
			name = getweaponname(userid, param)
			if name == ["weapon_none"]:
				continue
			for item in name:
				weapons.append(item)
				if item in handles:
					handles[item].append(handle)
				else:
					handles[item] = [handle]
		else:
			if param in handles:
				handles[param].append(handle)
			else:
				handles[param] = [handle]
	for weaponname in weapons:
		weapon = es.createentitylist(weaponname)
		for index in weapon:
			if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") in handles[weaponname]:
				setentname(index, "theweapon")
	es.fire(es.getuserid(), "theweapon", "Kill")
def restrict(users, param):
	if str(param) in "1234":
		return
	if str(param) == "mp5":
		param = "mp5navy"
	item = "weapon_%s" % param
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	for userid in getusers(users):
		if not item in restrict_list[userid]:
			restrict_list[userid].append(item)
def restrictall(users):
	global restrict_list
	global allweapons
	for userid in getusers(users):
		restrict_list[userid] = allweapons
def rocket(users):
	# smoke sprites -> explosion white ring -> bones (optional)
	shake(users, 10, 40, 20)
	for userid in getusers(users):
		es.emitsound("player", userid, "weapons/rpg/rocketfire1.wav", 0.5, 0)
		gamethread.delayed(1, es.emitsound, ("player", userid, "weapons/rpg/rocket1.wav", 0.5, 0))
		vec = vecmath.vector(es.getplayerprop(userid, "CBaseEntity.m_vecOrigin"))
		gamethread.delayed(1, rocket_loop, (userid, 0, vec[2], vec[2]))
def rocket_loop(userid, count, height, oldheight):
	physpush(userid, 0, 0, 250)
	origin = es.getplayerprop(userid, "CBaseEntity.m_vecOrigin")
	vec = vecmath.vector(origin)
	if vec[2] >= height or count < 10:
		gamethread.delayed(0.2, rocket_loop, (userid, count + 1, vec[2], height))
	else:
		es.stopsound(userid, "weapons/rpg/rocket1.wav")
		es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", 0.5, 0)
		es.ServerCommand("es_xgive %s env_explosion" % userid)
		es.ServerCommand("es_delayed 0 es_setentityname server_var(eventscripts_lastgive) theexplosion")
		vec = vecmath.vector(es.getplayerprop(userid, "CBaseEntity.m_vecOrigin"))
		vec[2] += 50
		es.ServerCommand('es_delayed 0 es_fire %s theexplosion addoutput "origin %f %f %f"' % (userid, vec[0], vec[1], vec[2]))
		es.ServerCommand('es_delayed 0 es_fire %s theexplosion addoutput "iRadiusOverride %s"' % (userid, 100))
		es.ServerCommand('es_delayed 0 es_fire %s theexplosion addoutput "iMagnitude %s"' % (userid, 100))
		es.ServerCommand("es_delayed 0 es_fire %s theexplosion explode" % userid)
		es.ServerCommand("es_delayed 0 est_slay %s" % userid)
def setammo(users, param, value):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			player.setPrimaryAmmo(int(value))
		if secondary in name:
			player.setSecondaryAmmo(int(value))
def setarmor(users, value):
	armor(users, "=", value)
def setcash(users, value):
	cash(users, "=", value)
def setclipammo(users, param, value):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		primary = player.getPrimary()
		secondary = player.getSecondary()
		name = getweaponname(userid, param)
		if primary in name:
			player.setPrimaryClip(int(value))
		if secondary in name:
			player.setSecondaryClip(int(value))
def setentname(index, param):
	# nt.entitySetName(index, param)
	es.setentityname(index, param)
def setgravity(users, ratio):
	global gravity_list
	for userid in getusers(users):
		gravity_list[userid] = float(ratio)
		es.fire(userid, "!self", "addoutput", "gravity %f" % float(ratio))
def sethealth(users, value):
	health(users, "=", value)
def setmodel(users, model):
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setModel(model)
def setplayercolor(users, r, g, b, a, weapon):
	w = int(weapon)
	for userid in getusers(users):
		player = playerlib.getPlayer(userid)
		player.setColor(int(r), int(g), int(b), int(a))
		if w == 1:
			player.setWeaponColor(int(r), int(g), int(b), int(a))
def shake(users, time, distance, value):
	es.usermsg("create", "shake", "Shake")
	es.usermsg("write", "byte", "shake", 0)
	es.usermsg("write", "float", "shake", float(value))
	es.usermsg("write", "float", "shake", float(distance))
	es.usermsg("write", "float", "shake", float(time))
	for userid in getusers(users):
		es.usermsg("send", "shake", userid)
	es.usermsg("delete", "shake")
def slay(users):
	damage(0, users, 10000)
def spawn(users, param = 0):
	gamethread.delayed(0.15, spawn_delayed, (users, param))
def spawn_delayed(users, param):
	global spawn_restrict
	for userid in getusers(users):
		dead = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
		es.ServerCommand("es_setplayerprop %s CBasePlayer.m_lifeState 512" % userid)
		es.ServerCommand("es_setplayerprop %s CCSPlayer.m_iPlayerState 0" % userid)
		es.ServerCommand("es_spawnplayer %s" % userid)
def speed(users, value):
	for userid in getusers(users):
		es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", value)
def stopsound(users, param):
	for userid in getusers(users):
		es.stopsound(userid, param)
def stripplayer(users, param = 0):
	trigger = es.getuserid()
	es.ServerCommand("es_xgive %s player_weaponstrip" % trigger)
	for userid in getusers(users):
		if str(param) != "0":
			es.fire(userid, "player_weaponstrip", "StripWeaponsAndSuit")
		else:
			es.fire(userid, "player_weaponstrip", "Strip")
	es.fire(trigger, "Strip", "Kill")
def team(users, no):
	for userid in getusers(users):
		if int(no) > 1:
			es.setplayerprop(userid, "CBaseEntity.m_iTeamNum", int(no))
			es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
		if int(no) <= 1:
			es.changeteam(userid, int(no))
def teleport(users, x, y, z):
	for userid in getusers(users):
		es.setpos(userid, float(x), float(y), float(z))
def unregclientcmd(command):
	global regclientcmd_list
	if [command, 0] in regclientcmd_list:
		regclientcmd_list.remove([command, 0])
	if [command, 1] in regclientcmd_list:
		regclientcmd_list.remove([command, 1])
def unrestrict(users, param):
	if str(param) in "1234":
		return
	if str(param) == "mp5":
		param = "mp5navy"
	item = "weapon_%s" % param
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	for userid in getusers(users):
		if item in restrict_list[userid]:
			restrict_list[userid].remove(item)
def unrestrictall(users):
	global restrict_list
	for userid in getusers(users):
		restrict_list[userid] = []
def uptime():
	global starttime
	return time.time() - starttime

def es_player_chat(event_var):
	userid = event_var["userid"]
	if int(userid) <= 0:
		return
	team = es.getplayerprop(userid, "CBaseEntity.m_iTeamNum")
	flag = 0
	if team == 1:
		if not int(event_var["teamonly"]):
			players = playerlib.getPlayerList("#alive")
			type = "#Cstrike_Chat_AllSpec"
			flag = 1
	elif es.getplayerprop(userid, "CBasePlayer.pl.deadflag") == 1:
		flag = 1
		if int(event_var["teamonly"]):
			if team == 2:
				str = "#t,#alive"
				type = "#Cstrike_Chat_T_Dead"
			if team == 3:
				str = "#ct,#alive"
				type = "#Cstrike_Chat_CT_Dead"
			players = playerlib.getPlayerList(str)
		else:
			players = playerlib.getPlayerList("#alive")
			type = "#Cstrike_Chat_AllDead"
	if flag:
		name = es.getplayername(userid)
		text = event_var["text"]
		es.usermsg('create', 'deadchat', 'RadioText')
		es.usermsg('write', 'byte', 'deadchat', event_var["es_userindex"])
		es.usermsg('write', 'byte', 'deadchat', 1)
		es.usermsg('write', 'string', 'deadchat', type)
		es.usermsg('write', 'string', 'deadchat', unicode(name))
		es.usermsg('write', 'string', 'deadchat', unicode(text))
		for player in players:
			es.usermsg('send', 'deadchat', player.userid)
		es.usermsg('delete', 'deadchat')

def player_connect(event_var):
	global restrict_list
	global gravity_list
	global deaths_list
	userid = int(event_var["userid"])
	restrict_list[userid] = []
	gravity_list[userid] = 1.0
	deaths_list[userid] = 0

def player_disconnect(event_var):
	global restrict_list
	global gravity_list
	global deaths_list
	userid = int(event_var["userid"])
	del restrict_list[userid]
	del gravity_list[userid]
	del deaths_list[userid]

def player_death(event_var):
	global deaths_list
	userid = int(event_var["userid"])
	deaths_list[userid] += 1

def item_pickup(event_var):
	# we have to think about autobuy and rebuy
	userid = int(event_var["userid"])
	item = "weapon_%s" % event_var["item"]
	if item == "weapon_mp5":
		item = "weapon_mp5navy"
	global allweapons
	if not item in allweapons:
		return
	global restrict_list
	restricts = restrict_list[userid]
	if item in restricts:
		removeweapon(userid, item)

def es_map_start(event_var):
	global loop_count
	global modified_deaths
	loop_count = 0
	modified_deaths = 0
	gamethread.cancelDelayed("est_func_loop")
	est_func_loop()

def round_start(event_var):
	global timer
	timer = time.time()

def clientcommandfilter(userid, args):
	global regclientcmd_list
	global restrict_list
	if args[0] == "buy" and es.getplayerprop(userid, "CCSPlayer.m_bInBuyZone"):
		restricts = restrict_list[userid]
		item = "weapon_%s" % args[1]
		if item == "weapon_mp5":
			item = "weapon_mp5navy"
		if item in restricts:
			es.playsound(userid, "buttons/weapon_cant_buy.wav", 1.0)
			return False
	for item in regclientcmd_list:
		if item[0] == args[0]:
			es.event("initialize", "est_cmdhook")
			es.event("setint", "est_cmdhook", "userid", userid)
			es.event("setstring", "est_cmdhook", "hooktext", args[0])
			es.event("setstring", "est_cmdhook", "commandstring", str(args[1:]))
			es.event("fire", "est_cmdhook")
			if item[1]: return True
			else: return False
	return True

def getweaponname(userid, param):
	if str(param) in "1234":
		p = int(param)
		player = playerlib.getPlayer(userid)
		gun = False
		if p == 1:
			gun = player.getPrimary()
		if p == 2:
			gun = player.getSecondary()
		if gun != False:
			return [gun]
		if p == 3:
			return ["weapon_knife"]
		if p == 4:
			name = []
			if player.getHE() > 0:
				name.append("weapon_hegrenade")
			if player.getSG() > 0:
				name.append("weapon_smokegrenade")
			if player.getFB() > 0:
				name.append("weapon_flashbang")
			if name != []:
				return name
	else:
		if param.startswith("weapon_"):
			return [param]
		else:
			if param == "mp5":
				param = "mp5navy"
			if param != "":
				return ["weapon_%s" % param]
	return ["weapon_none"]

def getusers(users):
	#TODO: http://www.eventscripts.com/pages/Est_PlayerSelection
	# Python style #alive, #all, #bot, #ct, #dead, #human, #spec, #t, #un
	# ex: #alive,#ct (for CT who is alive)
	# EST style #a, #c, #3, #t, #2, #s, #1, #u, #0, #h, #b, #l, #d
	# ex: #23!d (for all T and CT who is alive)
	# issue 1: #ct (use #tc or #23 instead for EST style)
	# issue 2: names start with # are not supported
	pyfilter = ["#alive", "#all", "#bot", "#ct", "#dead", "#human", "#spec", "#t", "#un"]
	if str(users)[0] == "#":
		status = 0
		notfilter = ""
		if "," in users:
			status = 1
		if "!" in users:
			all = users.split("!")
			users = all[0]
			notfilter = all[1]
			status = 2
		if status == 0:
			if users in pyfilter:
				status = 1
			else:
				status = 2
		if status == 2:
			est = [["t","#t"], ["c","#ct"], ["3","#ct"], ["2","#t"], ["s","#spec"], ["1","#spec"], ["u","#un"], ["h","#human"], ["b","#bot"], ["l","#alive"], ["a","#all"], ["d","#dead"] ]
			filter = []
			for item in est:
				if item[0] in users:
					idlist = playerlib.getUseridList(item[1])
					filter.extend(idlist)
			users = set(filter)
			if notfilter != "":
				filter = []
				for item in est:
					if item[0] in notfilter:
						idlist = playerlib.getUseridList(item[1])
						filter.extend(idlist)
				notfilter = set(filter)
				for item in notfilter:
					users.remove(int(item))
		else:
			users = playerlib.getUseridList(users)
	else:
		newusers = []
		all = playerlib.getUseridList("#all")
		for userid in all:
			if users == es.getplayersteamid(userid):
				newusers.append(userid)
			elif str(users) in es.getplayername(userid):
				newusers.append(userid)
		if newusers == []:
			test = str(users)
			if not "," in test:
				if test.isdigit():
					testid = int(test)
					if testid in all:
						return [testid]
				return []
		else:
			users = newusers
	if not hasattr(users, "__iter__"):
		users = (users,)
	return users

def unicode(text):
	# for unicode texts in usermsg
	status = 1
	error = ":; "
	for item in error:
		if item in text:
			status = 0
	if status:
		msg = '"' + text + '"'
	else:
		msg = text
	return msg

def est_func_loop():
	global modified_deaths
	if modified_deaths != 0:
		index = es.getentityindex("cs_player_manager")
		global deaths_list
		players = playerlib.getPlayerList("#all")
		for userid in players:
			es.setindexprop(index, "CPlayerResource.m_iDeaths.%.3d" % playerlib.getPlayer(userid).attributes["index"], deaths_list[int(userid)])
	gamethread.delayedname(0.01, "est_func_loop", est_func_loop)